#ifndef	AUTH_DONGLE_FIRMWARE_DEFS_H
#define	AUTH_DONGLE_FIRMWARE_DEFS_H

#include <xtalk/firmware_defs.h>

#define	AUTH_DONGLE_PROTO_VERSION	0x01
#define	AUTH_DONGLE_FW_VERSION_LEN	6

/* OP-codes */

enum {
/*
 * Reading block:
 *   - Host send "start" + offset
 *     - Dongle reply with "ack"
 *   - Host send "next"
 *     - Dongle reply with "next-reply" + data
 */
	AUTH_DONGLE_READ_START	 = 0x10,
	AUTH_DONGLE_READ_NEXT	 = 0x11,
	AUTH_DONGLE_READ_NEXT_REPLY =
		(AUTH_DONGLE_READ_NEXT | XTALK_REPLY_MASK),

/*
 * Writing block:
 *   - Host send "start" + offset
 *     - Dongle reply with "ack"
 *   - Host send "next" + data
 *     - Dongle reply with "ack"
 */
	AUTH_DONGLE_WRITE_START = 0x12,
	AUTH_DONGLE_WRITE_NEXT	 = 0x13,

	AUTH_DONGLE_FW_VERSION	= 0x21,
	AUTH_DONGLE_FW_VERSION_REPLY	=
		(AUTH_DONGLE_FW_VERSION | XTALK_REPLY_MASK),
};

#endif	/* AUTH_DONGLE_FIRMWARE_DEFS_H */
