#ifndef	AUTH_DONGLE_PROTO_H
#define	AUTH_DONGLE_PROTO_H
/*
 * Written by Oron Peled <oron@actcom.co.il>
 * Copyright (C) 2013, Xorcom
 *
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

/*
 * AUTH-DONGLE protocol
 */

#include <xtalk/proto_sync.h>
#include <auth-dongle/firmware_defs.h>

#ifdef	__GNUC__
#define	PACKED	__attribute__((packed))
#else
#define	PACKED
#endif

#define	AUTH_DONGLE_MAX_DATA	2

CMD_DEF(AUTH_DONGLE, READ_START,
	uint16_t offset;
	);

CMD_DEF(AUTH_DONGLE, READ_NEXT,
	uint8_t length;
	);

CMD_DEF(AUTH_DONGLE, READ_NEXT_REPLY,
	uint8_t data[0];
	);

CMD_DEF(AUTH_DONGLE, WRITE_START,
	uint16_t offset;
	);

CMD_DEF(AUTH_DONGLE, WRITE_NEXT,
	uint8_t data[0];
	);

CMD_DEF(AUTH_DONGLE, FW_VERSION,
	);

CMD_DEF(AUTH_DONGLE, FW_VERSION_REPLY,
	uint8_t data[AUTH_DONGLE_FW_VERSION_LEN];
	);


union XTALK_PDATA(AUTH_DONGLE) {
        MEMBER(AUTH_DONGLE, READ_START);
        MEMBER(AUTH_DONGLE, READ_NEXT);
        MEMBER(AUTH_DONGLE, READ_NEXT_REPLY);
        MEMBER(AUTH_DONGLE, WRITE_START);
        MEMBER(AUTH_DONGLE, WRITE_NEXT);
        MEMBER(AUTH_DONGLE, FW_VERSION);
        MEMBER(AUTH_DONGLE, FW_VERSION_REPLY);
} PACKED;

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif	/* AUTH_DONGLE_PROTO_H */
